//+-------------------------------------------------------------------+
//|                   Generic auto trading robot by Steve Hopwood.mq4 |
//|                                  Copyright  2009, Steve Hopwood  |
//|                              http://www.hopwood3.freeserve.co.uk  |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  none "None"
#define  buy "Buy"
#define  sell "Sell"
#define  ranging "Ranging"
#define  confused "Confused, and so cannot trade"
#define  trending "Trending"
#define  opentrade "There is a trade open"
#define  stopped "Trading is stopped"
#define  line "Pivot line"
#define  increasing "Rising, so the robot will trade"
#define  shrinking "Falling, so the robot will not trade"
#define  notmoving "Static, so the robot will not trade"


/*

Matt Kennel has provided the code for bool O_R_CheckForHistory(int ticket). Cheers Matt, You are a star.



Code for adding debugging Sleep
int x = 0;
while (x == 0) Sleep(100);

FUNCTIONS LIST
int init()
int start()

----Trading----

void StartTradingSequence()
void SendNewPendingTrade()
bool IsTradingAllowed()
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool DoesTradeExist()
void CountOpenTrades()
void LookForTradeClosure()
bool CheckTradingTimes()
void CloseAllTrades()


----Matt's Order Reliable library code
bool O_R_CheckForHistory(int ticket) Cheers Matt, You are a star.
void O_R_Sleep(double mean_time, double max_time)

----Indicator readings---- 
void ReadIndicatorValues()
void GetBB(int shift)
double GetRsi(int tf, int period, int ap, int shift)
double GetMa(int tf, int period, int mashift, int method, int ap, int shift)
double CalculateVolatility(int period, int LookBack)

----Pivot----
void GetPivot()
void DrawPivot(double pivot)


----Trend detection module----
void TrendDetectionModule()





*/

extern string  gen="----General inputs----";
extern double  Lot=0.01;
extern bool    StopTrading=false;
extern bool    TradeLong=true;
extern bool    TradeShort=true;
extern int     TakeProfit=30;
extern int     StopLoss=60;
extern int     MagicNumber=0;
extern string  TradeComment="";
extern bool    CriminalIsECN=true;
extern int     MaxSpread=40;
extern bool    UseSafetyFeature=true;

extern string  ms="----Martingale----";
extern double  MartingaleMultiplier=0;
extern int     MaxLots=3.84;

extern string  sc="----Post basket closure sleep time----";
extern int     SleepMinsAfterClosure=0;

extern string  bbi="----Bollinger Band volatility filter----";
extern bool    UseBands=true;
extern int     BbPeriod=20;
extern int     BbDeviation=2;

extern string  piv="----Pivot----";
extern bool    UsePivot=true;
extern int     PivotTimeFrame=1440;
extern bool    CriminalHasSundayCandle=true;


extern string  tdm="----Trend detection module----";
extern bool    RisingTrend=false;
extern bool    FallingTrend=false;
extern bool    UseTrendDetection=true;
extern string  trsi="Rsi trend detection";
extern bool    UseRsiTrendDetection=false;
extern int     RsiTdTf=1440;
extern int     RsiTdPeriod=20;
extern string  trs="Applied price: 0=Close; 1=Open; 2=High";
extern string  trs1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     RsiTdAppliedPrice=0;

//Fast ma > slow, trend is up & vice versa
extern string  tmas="Two MA - 'slowkey'";
extern bool    UseSlowkey=false;
extern int     FastMaTdTF=0;//Time frame defaults to current chart 
extern int     FastMaTdPeriod=100;
extern int     FastMaTdShift=0;//The MA Shift input
extern string  tmame="Method: 0=sma; 1=ema; 2=smma;  3=lwma";
extern int     FastMaTdMethod=0;
extern string  tmaap="Applied price: 0=Close; 1=Open; 2=High";
extern string  tmaap1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     FastMaTdAppliedPrice=0;
extern int     SlowMaTdTF=0;//Time frame defaults to current chart 
extern int     SlowMaTdPeriod=200;
extern int     SlowMaTdShift=0;
extern int     SlowMaTdMethod=0;
extern int     SlowMaTdAppliedPrice=0;

//Single, much longer term MA. Rising MA the trend is up and vice-versa
extern string  sima="Single moving average";
extern bool    UseMaTrendDetection=false;
extern int     SingleMaTdTF=10080;//Time frame defaults to W1
extern int     SingleMaTdPeriod=10;
extern int     SingleMaTdShift=0;//The MA Shift input
extern string  stmame="Method: 0=sma; 1=ema; 2=smma;  3=lwma";
extern int     SingleMaTdMethod=0;
extern string  stmaap="Applied price: 0=Close; 1=Open; 2=High";
extern string  stmaap1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     SingleMaTdAppliedPrice=0;
extern int     CompareWithCandles=5;
extern int     MinimumAcceptableRise=300;//Pure guesswork to make sure there has bee a decent movement in the ma

extern string  amc="----Available Margin checks----";
extern string  sco="Scoobs";
extern bool    UseScoobsMarginCheck=false;
extern string  fk="ForexKiwi";
extern bool    UseForexKiwi=true;
extern int     FkMinimumMarginPercent=1500;


extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;

extern string  mis="----Odds and ends----";
extern int     DisplayGapSize=30;


//Matt's O-R stuff
int 	         O_R_Setting_max_retries 	= 10;
double 	      O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	      O_R_Setting_sleep_max 		= 15.0; /* seconds */

//Trading variables
int            TicketNo;
bool           FilledOpen, PendingOpen;

//BB variables
double         BbUpper, BbMiddle, BbLower, BbExtent, PrevBbExtent;
string         BbVolatility;

//Rsi
double         RsiVal;

//Moving average
double         MaVal;

//Volatility
double         Volatility;

//Date/Time
datetime       ConvertedStartTime;

//Trend detection
string         trend;
double         TrendRsiVal;//Rsi
double         FastTrendMaVal, SlowTrendMaVal;//2 MA trend
double         SingleTrendMaVal, PrevSingleTrendMaVal;//Single trend ma

//Misc
string         Gap, ScreenMessage;
int            OldBars;
string         PipDescription=" pips";
bool           ForceTradeClosure;
bool           RobotSuspended;

void DisplayUserFeedback()
{
   
   if (IsTesting() && !IsVisualMode()) return;

   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL );
   /*
   //Code for time to bar-end display from Candle Time by Nick Bilak
   double i;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, m + " minutes " + s + " seconds left to bar end", NL);
   */
      
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Take profit: ", TakeProfit, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Stop loss: ", StopLoss, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = false", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Criminal's minimum lot size: ", MarketInfo(Symbol(), MODE_MINLOT), NL, NL );
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours", NL);
   if (start_hourm == 0 && end_hourm == 12 && start_houre && end_houre == 24) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            24H trading", NL);
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_hourm: ", DoubleToStr(start_hourm, 2), 
                      ": end_hourm: ", DoubleToStr(end_hourm, 2), NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_houre: ", DoubleToStr(start_houre, 2), 
                      ": end_houre: ", DoubleToStr(end_houre, 2), NL);
                      
   }//else
   
   
   //Trend
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trend is ", trend, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   if (UseTrendDetection)
   {
      //Rsi
      if (UseRsiTrendDetection)
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trend Rsi ", TrendRsiVal, NL);
      }//if (UseRsiTrendDetection)
      
      //slowkey 2 moving average
      if (UseSlowkey)
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Fast MA ", FastTrendMaVal, ":  Slow MA ", SlowTrendMaVal,  NL);
      }//if (UseSlowkey)
      
      //Single moving average
      if (UseMaTrendDetection)
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Current MA ", DoubleToStr(SingleTrendMaVal, Digits), ":  ", CompareWithCandles, " candles ago ", DoubleToStr(PrevSingleTrendMaVal, Digits),  NL);
      }//if (UseMaTrendDetection)
   }//if (UseTrendDetection)
   
   if (UseBands)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Current BB width ", DoubleToStr(BbExtent, Digits), ":  Previous BB width ", DoubleToStr(PrevBbExtent, Digits), ": Volatility is ", BbVolatility, NL, NL);
   }//if (UseBands)
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours", NL);

   //ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Rsi: ", RsiVal, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Moving average: ", MaVal, NL);
   

   
   Comment(ScreenMessage);


}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----

   //Adapt to x digit criminals
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   if (multiplier > 1) PipDescription = " points";
   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;

   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   

   if (TradeComment == "") TradeComment = " ";
   
   DisplayUserFeedback();
   
   if (UseSafetyFeature)
   {
      
      int retval = MessageBox(Symbol() + ": do you wish to continue to use this robot?", "Question", MB_YESNO|MB_ICONQUESTION);
      if (retval == IDNO) RobotSuspended = true;
      else RobotSuspended = false;   
   }//if (UseSafetyFeature)

   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}


bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
      
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);

   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   
   if (CriminalIsECN && (type == OP_BUYSTOP || type == OP_SELLSTOP) ) 
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   }//if (CriminalIsECN && (type == OP_BUYSTOP || OrderType() == OP_SELLSTOP) ) 
   
   //Is a 2 stage criminal
   if (CriminalIsECN && (type == OP_BUY || type == OP_SELL) )
   {
      bool result;
      int err;
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
      if (ticket > 0)
      {
	     
	     if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take > 0 && stop > 0)
      
	     if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

      }//if (ticket > 0)
        
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket <= 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
      if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      Alert(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   

   TicketNo = ticket;
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades
   O_R_CheckForHistory(ticket); 
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
/*
bool DoesTradeExist()
{
   
   TicketNo = -1;
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         TicketNo = OrderTicket();
         return(true);         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()
*/


bool IsTradingAllowed()
{
   //Returns false if any of the filters should cancel trading, else returns true to allow trading
   
      
   //Maximum spread
   if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpread) return(false);
 
   //Volatility measured by BB
   if (UseBands) GetBB();
   if (!UseBands) BbVolatility = increasing;

   
   return(true);


}//End bool IsTradingAllowed()


void StartTradingSequence()
{


   RefreshRates();
   double take, stop, price;
   int type;

   //Check filters
   if (!IsTradingAllowed() ) return;

   if (BbVolatility != increasing) return;//Set to increasing by default if !UseBands

   //Trend
   string Ttrend = trend;//Temp trend string
   if (!UseTrendDetection) Ttrend = up;//Set up a dummy if the user is not using the trend stuff
   
   //Long 
   if (Ttrend == up)
   {
      if (!TradeLong) return;

      //Market trade
      take = NormalizeDouble(Ask + (TakeProfit * Point), Digits);
      stop = NormalizeDouble(Ask - (StopLoss * Point), Digits);
      bool result = SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, stop, take);
      if (!result) return;
      if (UseSafetyFeature) RobotSuspended = true;
      
      return;
   }//if (Ttrend == up)
   
   if (!UseTrendDetection) Ttrend = down;//Set up a dummy if the user is not using the trend stuff
   
   //Short
   if (Ttrend == down)
   {
      if (!TradeShort) return;

      //Market trade
      take = NormalizeDouble(Bid - (TakeProfit * Point), Digits);
      stop = NormalizeDouble(Bid + (StopLoss * Point), Digits);
      result = SendSingleTrade(OP_SELL, TradeComment, Lot, Bid, stop, take);
      if (!result) return;
      if (UseSafetyFeature) RobotSuspended = true;
      
      
      
   }//if (Ttrend == down)
   

   

}//void StartTradingSequence()

////////////////////////////////////////////////////////////////////////////////////////////////
//Indicator module


void GetBB()
{
   //Reads BB figures into BbUpper, BbMiddle, BbLower
   
   
   BbUpper = iBands(NULL, 0, BbPeriod, BbDeviation, 0, PRICE_OPEN, MODE_UPPER, 0);
   BbLower = iBands(NULL, 0, BbPeriod, BbDeviation, 0, PRICE_OPEN, MODE_LOWER, 0);
   BbMiddle = iBands(NULL, 0, BbPeriod, BbDeviation, 0, PRICE_OPEN, MODE_MAIN, 0);
   
   BbExtent = BbUpper - BbLower;

   double PrevBbUpper = iBands(NULL, 0, BbPeriod, BbDeviation, 0, PRICE_OPEN, MODE_UPPER, 1);
   double PrevBbLower = iBands(NULL, 0, BbPeriod, BbDeviation, 0, PRICE_OPEN, MODE_LOWER, 1);
   
   PrevBbExtent = PrevBbUpper - PrevBbLower;
   BbVolatility = notmoving;
   if (BbExtent > PrevBbExtent) BbVolatility = increasing;
   if (BbExtent < PrevBbExtent) BbVolatility = shrinking;
   
   
}//void GetBb()



double GetRsi(int tf, int period, int ap, int shift)
{
   return(iRSI(NULL, tf, period, ap, shift) );
}//End double GetRsi(int tf, int period, int ap, int shift)



double GetMa(int tf, int period, int mashift, int method, int ap, int shift)
{
   return(iMA(NULL, tf, period, mashift, method, ap, shift) );
}//End double GetMa(int tf, int period, int mashift, int method, int ap, int shift)

/*
double CalculateVolatility(int period, int LookBack)
{
   //Calculates the volatility of a pair based on an average of their movement over LookBack periods
   
   double pips;
   for (int cc = 1; cc < LookBack; cc++)
   {
      pips+= iHigh(NULL, period, cc) - iLow(NULL, period, cc);      
   }//for (int cc = 1; cc < LookBack; cc++)
   
   pips/= LookBack;//Average pips movement per day
   //Alert(pips);

   //Convert to pips
   int multiplier;
   if (Digits == 2) multiplier = 10;
   if (Digits == 3) multiplier = 100;
   if (Digits == 4) multiplier = 1000;
   if (Digits == 5) multiplier = 10000;
   
   pips*= multiplier;
   int rpips = pips;//Convert to a simple integer - all we need
   
   return(rpips);
   
}//End double CalculateVolatility(int period, int LookBack)
*/


void GetPivot()
{
   int day = TimeDayOfWeek(TimeCurrent() );
   int shift = 1;
   if (PivotTimeFrame == PERIOD_D1 && day == 1 && CriminalHasSundayCandle) shift = 2;//Deal with the Monday cabdle
   
   double pivot = NormalizeDouble((iHigh(NULL, PivotTimeFrame, shift) + iLow(NULL, PivotTimeFrame, shift)) / 2, Digits);
   DrawPivot(pivot);
}//void GetPivot()


void DrawPivot(double pivot)
{

   ObjectDelete(line);
   
   ObjectCreate(line,1,0,TimeCurrent(), pivot);
   ObjectSet(line,OBJPROP_COLOR,Yellow);
   ObjectSet(line,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(line,OBJPROP_WIDTH,1);    

}//void DrawPivot(double pivot)

/*
void ReadIndicatorValues()
{

   //GetBB(0);
   //RsiVal = GetRsi(RsiTf, RsiPeriod, RsiAppliedPrice, 0);
   //MaVal = GetMa(MaTF, MaPeriod, MaShift, MaMethod, MaAppliedPrice, 0);
   //Volatility = CalculateVolatility(PERIOD_D1, LookBackDays);
   
}//void ReadIndicatorValues()
*/
//End Indicator module
////////////////////////////////////////////////////////////////////////////////////////////////

void CloseAllTrades()
{
   ForceTradeClosure= false;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == Symbol() )
      {
         while(IsTradeContextBusy()) Sleep(100);
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
         if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) result = OrderDelete(OrderTicket(), CLR_NONE);
         if (result) cc++;
         if (!result) ForceTradeClosure= true;
      }//if (OrderSymbol() == Symbol() )
   
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)


}//End void CloseAllTrades()


bool CheckTradingTimes()
{
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = true;
	
	ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      ok2Trade = false;
   }//if (hour >= MathMax(end_hourm, end_houre))

   return(ok2Trade);

}//bool CheckTradingTimes()

void CountOpenTrades()
{
   TicketNo = -1;
   FilledOpen = false;
   PendingOpen = false;

   if (OrdersTotal() == 0) return;
   
   for (int cc = 0; cc <= OrdersTotal(); cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) 
         {
            FilledOpen = true;
            //Only need the ticket number of the most recent filled trade
            TicketNo = OrderTicket();
         }//if (OrderType() == OP_BUY || OrderType() == OP_SELL) 
         
         if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) 
         {
            PendingOpen = true;            
         }//if (OrderType() == OP_BUY || OrderType() == OP_SELL) 
         
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
   }//for (int cc = 0; cc < OrdersTotal() - 1; cc++)
   
   
}//End void CountOpenTrades();

//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
         Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
      Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)





///////////////////////////////////////////////////////////////////////////////////////////////////////
//Trend detection module

void TrendDetectionModule()
{

   //Define the trend according to the user's choices.
   //Only called if UseTrendDetection is set to true
   trend = ranging;//Default
   
   //Rsi. This one is scooby-doo's suggestion and is based on a 20 period D1 Rsi.
   if (UseRsiTrendDetection)
   {
      TrendRsiVal = GetRsi(RsiTdTf, RsiTdPeriod, RsiTdAppliedPrice, 0);
      if (TrendRsiVal > 55) trend = up;
      if (TrendRsiVal < 45) trend = down;
   }//if (UseRsiTrendDetection)

   //'slowkey' - double moving average.
   //Slow MA > Fast MA - trend is up and vice versa
   if (UseSlowkey)
   {
      FastTrendMaVal = GetMa(FastMaTdTF, FastMaTdPeriod, FastMaTdShift, FastMaTdMethod, FastMaTdAppliedPrice, 0);   
      SlowTrendMaVal = GetMa(SlowMaTdTF, SlowMaTdPeriod, SlowMaTdShift, SlowMaTdMethod, SlowMaTdAppliedPrice, 0); 
      if (FastTrendMaVal > SlowTrendMaVal) trend = up;
      if (FastTrendMaVal < SlowTrendMaVal) trend = down;
   }//if (UseSlowkey)

   /*
   I picked this up from the book 'Trading Day by Day - Winning the Zero Sum Game' by FH Goslin.
   10 week MA is rising - trend is up.
   10 week MA is falling - trend is down.
   */
   if (UseMaTrendDetection)
   {
      SingleTrendMaVal = GetMa(SingleMaTdTF, SingleMaTdPeriod, SingleMaTdShift, SingleMaTdMethod, SingleMaTdAppliedPrice, 0);   
      PrevSingleTrendMaVal = GetMa(SingleMaTdTF, SingleMaTdPeriod, SingleMaTdShift, SingleMaTdMethod, SingleMaTdAppliedPrice, CompareWithCandles);   
      if (SingleTrendMaVal > PrevSingleTrendMaVal &&  SingleTrendMaVal - PrevSingleTrendMaVal >= (MinimumAcceptableRise * Point) ) trend = up;
      if (SingleTrendMaVal < PrevSingleTrendMaVal &&  PrevSingleTrendMaVal - SingleTrendMaVal >= (MinimumAcceptableRise * Point) ) trend = down;      
   }//if (UseMaTrendDetection)
   
   //Define initial trade direction from the chart's pivot line
   if (UsePivot)
   {
      if (ObjectFind(line) > -1)
      {
         double LineVal = ObjectGet(line, OBJPROP_PRICE1);
         RefreshRates();
         
         trend = ranging;
         if (Bid > LineVal) trend = up;
         if (Bid < LineVal) trend = down;
         
      }//if (ObjectFind(line) > -1
      
   }//if (UsePivot)

}//void TrendDetectionModule()


//End Trend detection module
///////////////////////////////////////////////////////////////////////////////////////////////////////


void SendNewPendingTrade()
{
   //Called when there is a filled trade open but no pending hedge in place
      
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return;
   if (OrderCloseTime() > 0) return;
   
   RefreshRates();
   double take, stop, price;
   int type;

   //Calculate hedge lot size
   double SendLots;
   if (OrderLots() == Lot) SendLots = Lot * 3;//First hedge triple initial lot size
   if (OrderLots() > Lot) SendLots = OrderLots() * 2;//Subsequent trades double the previous lot size
   if (MartingaleMultiplier > 0) SendLots = OrderLots() * MartingaleMultiplier;//Allows the user to customise the martingale lot multiplier
   if (SendLots > MaxLots) return;
   
   //Sell hedge
   if (OrderType() == OP_BUY)
   {
      if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return;
      price = NormalizeDouble(OrderOpenPrice() - (TakeProfit * Point), Digits);
      take = NormalizeDouble(price - (TakeProfit * Point), Digits);
      stop = NormalizeDouble(price + (StopLoss * Point), Digits);
      if (IsTradeContextBusy() ) Sleep(100);
      SendSingleTrade(OP_SELLSTOP, TradeComment, SendLots, price, stop, take);
      
   }//if (OrderType == OP_BUY)
   
   //Buy hedge
   if (OrderType() == OP_SELL)
   {
      //Pending trade
      if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return;
      price = NormalizeDouble(OrderOpenPrice() + (TakeProfit * Point), Digits);
      take = NormalizeDouble(price + (TakeProfit * Point), Digits);
      stop = NormalizeDouble(price - (StopLoss * Point), Digits);
      if (IsTradeContextBusy() ) Sleep(100);
      SendSingleTrade(OP_BUYSTOP, TradeComment, SendLots, price, stop, take);
      
      
   }//if (OrderType == OP_SELL)
   
   
   
}//void SendNewPendingTrade()

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   
   if (OrdersTotal() == 0)
   {
      TicketNo = -1;
      ForceTradeClosure = false;
   }//if (OrdersTotal() == 0)

   if (ForceTradeClosure) 
   {
      CloseAllTrades();
      return;
   }//if (ForceTradeClosure) 

   //ReadIndicatorValues();

   //Pivot
   if (UsePivot && OldBars != iBars(NULL, PivotTimeFrame) )
   {
      OldBars = iBars(NULL, PivotTimeFrame);
      GetPivot();
   }//if (UsePivot && OldBars != iBars(NULL, PivotTimeFrame)
   
   //Draw a yellow line if one does not already exist
   if (ObjectFind(line) == -1 && UsePivot) 
   {
      GetPivot();      
   }//if (ObjectFind(line) == -1) 

   
      
   ///////////////////////////////////////////////////////////////////////////////////////////////
   //Find open trades.
   static bool OldFilledOpen;
   OldFilledOpen = FilledOpen;
   CountOpenTrades();
   //Has a basket just closed?
   if (OldFilledOpen && !FilledOpen) 
   {
      if (PendingOpen) CloseAllTrades();
      Comment(Gap, "Sleeping after successful trade closure");
      Sleep(SleepMinsAfterClosure * 60000);
   }//if (OldFilledOpen && !FilledOpen) 
   
   //Delete pending once a trade has hit tp
   if (!FilledOpen && PendingOpen)
   {
      CloseAllTrades();
      return;   
   }//if (!FilledOpen && PendingOpen_
   
   //Add the next trade in the sequence if a pending has filled
   if (FilledOpen && !PendingOpen)
   {
      SendNewPendingTrade();
   }//if (!FilledOpen && PendingOpen_
   

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Trading times
   bool TradeTimeOk = CheckTradingTimes();
   if (!TradeTimeOk)
   {
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      return;
   }//if (hour < start_hourm)
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   //Available margin filters
   if (UseScoobsMarginCheck && FilledOpen > 0)
   {
      if(AccountMargin() > (AccountFreeMargin()/100)) 
      {
         Comment(Gap + "There is insufficient margin to allow trading. You might want to turn off the UseScoobsMarginCheck input.");
         return;
      }//if(AccountMargin() > (AccountFreeMargin()/100)) 
      
   }//if (UseScoobsMarginCheck)


   if (UseForexKiwi && AccountMargin() > 0)
   {
      
      double ml = NormalizeDouble(AccountEquity() / AccountMargin() * 100, 2);
      if (ml < FkMinimumMarginPercent)
      {
         Comment(Gap + "There is insufficient margin percent to allow trading. " + DoubleToStr(ml, 2) + "%");
         return;
      }//if (ml < FkMinimumMarginPercent)
      
   }//if (UseForexKiwi && AccountMargin() > 0)

   ///////////////////////////////////////////////////////////////////////////////////////////////         
   //Trading
   //Trend detection      
   if (UseTrendDetection) TrendDetectionModule();
   if (!UseTrendDetection && RisingTrend) trend = up;
   if (!UseTrendDetection && FallingTrend) trend = down;
   
  
   
   if (TicketNo == -1 && !StopTrading)
   {
      
      //Send initial trades in the sequence
      if (!RobotSuspended) StartTradingSequence();
   }//if (TicketNo == -1)
   ///////////////////////////////////////////////////////////////////////////////////////////////      

   if (!RobotSuspended) DisplayUserFeedback();
   else Comment("..........................................Robot suspended...........................................");
   
//----
   return(0);
}
//+------------------------------------------------------------------+